unit unit_SelectDir;

interface

{$WARN UNIT_PLATFORM OFF}

uses
  Windows, SysUtils, ShlObj,  ActiveX;
                                             //Graphics,, Dialogs , FileCtrl

type
  TSelDirExOption = (sdeShowFiles, sdeEditBox, sdeCreateButton,  sdeDirectorySelectOnly,
  { sdeShareable,} sdeDontGobelDomain);
  TSelDirOptions = set of TSelDirExOption;

function SelectDirectoryEx(const Caption: string; const Root: WideString;
  var Directory: string; Options: TSelDirOptions): Boolean;

implementation

uses
 Forms;


function SelectDirCB(Wnd: HWND; uMsg: UINT; lParam, lpData: LPARAM): Integer stdcall;
begin
  if (uMsg = BFFM_INITIALIZED) and (lpData <> 0) then
    SendMessage(Wnd, BFFM_SETSELECTION, Integer(True), lpData);
  Result := 0;
end;

function SelectDirectoryEx(const Caption: string; const Root: WideString;
  var Directory: string; Options: TSelDirOptions): Boolean;
var
  WindowList: Pointer;
  BrowseInfo: TBrowseInfo;
  Buffer: PChar;
  RootItemIDList, ItemIDList: PItemIDList;
  ShellMalloc: IMalloc;
  IDesktopFolder: IShellFolder;
  Eaten: LongWord;
  Flags: Cardinal;
begin
  Result := False;
  if not DirectoryExists(Directory) then
    Directory := '';
  FillChar(BrowseInfo, SizeOf(BrowseInfo), 0);
  if (ShGetMalloc(ShellMalloc) = S_OK) and (ShellMalloc <> nil) then
  begin
    Buffer := ShellMalloc.Alloc(MAX_PATH);
    try
      RootItemIDList := nil;
      if Root <> '' then
      begin
        SHGetDesktopFolder(IDesktopFolder);
        IDesktopFolder.ParseDisplayName(Application.Handle, nil,
          POleStr(Root), Eaten, RootItemIDList, Flags);
      end;
      with BrowseInfo do
      begin
        hwndOwner := Application.Handle;
        pidlRoot := RootItemIDList;
        pszDisplayName := Buffer;
        lpszTitle := PChar(Caption);             
        ulFlags := 0;
        if sdeShowFiles in Options then
          ulFlags := ulFlags or BIF_BROWSEINCLUDEFILES;
        if sdeEditBox in Options then
          ulFlags := ulFlags or BIF_EDITBOX;
        if sdeCreateButton in Options then
          ulFlags := ulFlags or $0040;
        if sdeDirectorySelectOnly in Options then
          ulFlags := ulFlags or BIF_RETURNONLYFSDIRS;
      {  if sdeShareable in Options then
          ulFlags := ulFlags or BIF_SHAREABLE;  }
        if sdeDontGobelDomain in Options then
          ulFlags := ulFlags or BIF_DONTGOBELOWDOMAIN;
        if Directory <> '' then
        begin
          lpfn := SelectDirCB;
          lParam := Integer(PChar(Directory));
        end;
      end;
      WindowList := DisableTaskWindows(0);
      try
        ItemIDList := ShBrowseForFolder(BrowseInfo);
      finally
        EnableTaskWindows(WindowList);
      end;
      Result := ItemIDList <> nil;
      if Result then
      begin
        ShGetPathFromIDList(ItemIDList, Buffer);
        ShellMalloc.Free(ItemIDList);
        Directory := Buffer;
      end;
    finally
      ShellMalloc.Free(Buffer);
    end;
  end;
end;

end.

